// VArray.cpp: implementation of the VArray class.
//
//////////////////////////////////////////////////////////////////////
#include "vstring.h"
#include "varray.h"

#include <stdio.h>
#include <stdlib.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

VArray::VArray()
{
	count = 0;
}

VArray::~VArray()
{
	int i;
	link *temp;

	for (i=0; i < count; i++)
	{
		temp = head;
		head = head->next;
		delete temp->data;
		delete temp;
	}
}

void VArray::Add(char *input)
{
	link *temp;
	
	temp = new link; // Create a new VString

	if (temp == NULL) { MemError(); }

	// Is this the first link?
	if (count == 0)
	{
		head = temp; // Set the head to the current link
		lastlink = temp;
		lastget = 0;
	}
	else
	{
		tail->next = temp; // Point the previous link to the current
	}
	temp->data = new VString; // Make a new VString and place the pointer in the current link.

	if (temp->data == NULL) { MemError(); }
	temp->data->Set(input); // Copy the input to the new VString
	tail = temp; // Point the tail to the current link
	count++;
}

VString * VArray::Get(int index)
{
	link *temp;
	int i;
	int start;

	if (count == 0)
	{
		printf("VArray error: no array entries yet");
		return NULL;
	}

	if (index > count)
	{
		printf("VArray error: request outside array");
		return tail->data;
	}

	if (index < 0)
	{
		printf("VArray error: request negative index");
		return head->data;
	}

	if (index >= lastget)
	{
		start = lastget;
		temp = lastlink;
	}
	else
	{
		start = 0;
		temp = head;
	}

	for (i = start; i < index; i++)
	{
		temp = temp->next;
	}

	lastget = index;
	lastlink = temp;

	return temp->data;
}

VString * VArray::GetLast()
{
	return tail->data;
}

int VArray::GetCount()
{
	return count;
}

void VArray::MemError()
{
	printf("\n\nMemory allocation error (VArray).\n");
	printf("Try to free more memory on your computer\n\n");
	printf("If this fails contact resgen@hltools.com\n");
	exit(2);
}
